#include <stdio.h>
#include <dos.h>
#include <wattcp.h>

/*
 * pcintr - add interrupt based processing, improve performance
 *          during disk slowdowns
 *
 * wintr_init()     - call once
 * wintr_shutdown() - called automatically
 * wintr_enable()   - enable interrupt based calls
 * wintr_disable()  - diable interrupt based calls (default)
 * (*wintr_chain)() - a place to chain in your own calls, must live
 *                    within something like 1K stack
 *
 */


#define TIMER 0x08
void (*wintr_chain)() = NULL;

# define	LOCSTACKSIZE	2048
static byte locstack[ LOCSTACKSIZE ];
static word on = 0;
static word inside = 0;
static word oldss, oldsp;
static void (_interrupt _far *oldint)(void);
static void _interrupt newint(void)
{
    (*oldint)();
    if ( !sem_up( &inside )) {
        if ( on ) {
            disable();
 //             oldss = _SS;
 //             oldsp = _SP;
 //             _SS = _DS;
 //             _SP = FP_OFF( &locstack[ sizeof( locstack ) - 4 ]);
		_asm
		{	mov	ax, ss
			mov	oldss, ax
			mov	ax, sp
			mov	oldsp, ax
			mov	ax, ds
			mov	ss, ax
			mov	sp, OFFSET locstack + LOCSTACKSIZE - 4
		}
            enable();

            if ( wintr_chain )
                (*wintr_chain)();
            tcp_tick( NULL );

            disable();
 //             _SS = oldss;
 //             _SP = oldsp;
		_asm
		{	mov	ss, oldss
			mov	sp, oldsp
		}
            enable();
        }
        inside = 0;
    }
}

void wintr_enable(void)
{
    on = 1;
}

void wintr_disable(void)
{
    on = 0;
}

void wintr_shutdown(void)
{
    setvect( TIMER, oldint );
}
void wintr_init(void)
{
    atexit( wintr_shutdown );
    oldint = _dos_getvect( TIMER );
    _dos_setvect( TIMER, newint );
}

